from open3d import *
import numpy as np
import matplotlib.pyplot as plt
import os
if __name__ == "__main__":
    # This starter file is modified from
    # http://www.open3d.org/docs/tutorial/Basic/index.html

    # Open3D does not support ppm/pgm file yet. Not using read_image here.
    # MathplotImage having some ISSUE with NYU pgm file. Not using imread for pgm.

    path = './NYU0001'

    #############################
    ### Calculate Point Cloud ###
    #############################
    # Load images and depth
    color_raw = read_image(os.path.join(path, 'img.jpg'))
    depth_raw = read_image(os.path.join(path, 'depth.png'))

    rgbd_image = create_rgbd_image_from_sun_format(color_raw, depth_raw)

    # Visualize rgb and depth images
    plt.subplot(1, 2, 1)
    plt.title('grayscale image')
    plt.imshow(rgbd_image.color)
    plt.subplot(1, 2, 2)
    plt.title('depth image')
    plt.imshow(rgbd_image.depth)
    plt.show()


    # The data is from NYU depth dataset.
    # Open3D contains the camera matrix for this dataset.
    pcd = create_point_cloud_from_rgbd_image(
        rgbd_image,
        PinholeCameraIntrinsic(
            PinholeCameraIntrinsicParameters.PrimeSenseDefault))

    ######################
    ### Point Cloud IO ###
    ######################
    # Save point cloud file
    # write_point_cloud("pointcloud.pcd", pcd)
    # Read point cloud file
    # pcd = read_point_cloud(os.path.join('NYU0020', 'pointcloud.pcd'))

    #############################
    ### Visualize Point Cloud ###
    #############################
    # Flip it, otherwise the pointcloud will be upside down in visualization
    pcd.transform([[1, 0, 0, 0], [0, -1, 0, 0], [0, 0, -1, 0], [0, 0, 0, 1]])
    # Visualize the point cloud
    draw_geometries([pcd])

    # You may want to downsample the point cloud before processing.
    # print("Downsample the point cloud with a voxel of 0.05")
    # downpcd = voxel_down_sample(pcd, voxel_size = 0.05)
    # draw_geometries([downpcd])
    # Turn into numpy array
    # np_pcd = np.asarray(down_pcd.points)
